package com.fr.plugin.http;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.plugin.IpTokenDecisionDBAccessProvider;
import com.fr.plugin.dao.UserIpDao;
import com.fr.plugin.entity.UserIpEntity;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public class ListIpApi extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/listIp";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        DBAccessor dbAccessor = IpTokenDecisionDBAccessProvider.getDbAccessor();

        List<UserIpEntity> entityList = dbAccessor.runQueryAction(daoContext ->{
            QueryCondition queryCondition = QueryFactory.create();

            List<UserIpEntity> entityList1 = daoContext.getDAO(UserIpDao.class).find(queryCondition);
            return entityList1;
        });
        JSONArray jsonArray = JSONArray.create(entityList);
        WebUtils.printAsJSON(httpServletResponse, jsonArray);
    }
}
